/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.fidentis.analyst.feature.services;

import cz.fidentis.analyst.feature.FeaturePoint;
import cz.fidentis.analyst.feature.utils.FeaturePointFileFormatTypes;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author kubok
 */
public class FeaturePointExportService {

    public void exportFeaturePoints(List<FeaturePoint> featurePointList, String objectName, String format) throws FileNotFoundException, IOException {
        switch (format) {
            case FeaturePointFileFormatTypes.FORMAT_TYPE_OBJ:
                exportFeaturePointsToCSV(featurePointList, objectName);
                break;
            case FeaturePointFileFormatTypes.FORMAT_TYPE_FP:
                exportFeaturePointsToFP(featurePointList, objectName);
                break;
            default:
                break;
        }
    }

    public void exportFeaturePointsToFP(List<FeaturePoint> featurePointList, String objectName) throws FileNotFoundException, IOException {
        File csvOutputFile = new File(String.format("%s_landmarks.fp", objectName));
        // CSV is a normal text file, need a writer
        try (BufferedWriter bw = new BufferedWriter(new FileWriter(csvOutputFile))) {
            bw.write(String.format("<!--Saved by software Fidentis Analyst--><facialPoints model=\"%s\">", objectName));
            featurePointList.forEach(featurePoint -> {
                try {
                    bw.newLine();
                    bw.write(String.format("<facialPoint type=\"%s\">", featurePoint.getFeaturePointType().getType()));
                    bw.newLine();
                    bw.write(String.format("<x>%f</x>", featurePoint.getX()));
                    bw.newLine();
                    bw.write(String.format("<y>%f</y>", featurePoint.getY()));
                    bw.newLine();
                    bw.write(String.format("<z>%f</z>", featurePoint.getZ()));
                } catch (IOException ex) {
                    Logger.getLogger(FeaturePointImportService.class.getName()).log(Level.SEVERE, null, ex);
                }
            });
            bw.newLine();
            bw.write("</facialPoints>");
        }

    }

    private void exportFeaturePointsToCSV(List<FeaturePoint> featurePointList, String objectName) throws IOException {
        File csvOutputFile = new File(String.format("%s_landmarks.fp", objectName));
        try (BufferedWriter bw = new BufferedWriter(new FileWriter(csvOutputFile))) {
            bw.write("Scan name");
            featurePointList.forEach(featurePoint -> {
                try {
                    bw.write(String.format(",%s x", featurePoint.getFeaturePointType().getCode()));
                    bw.write(String.format(",%s y", featurePoint.getFeaturePointType().getCode()));
                    bw.write(String.format(",%s z", featurePoint.getFeaturePointType().getCode()));
                } catch (IOException ex) {
                    Logger.getLogger(FeaturePointImportService.class.getName()).log(Level.SEVERE, null, ex);
                }
            });
            bw.newLine();
            bw.write(String.format("%s", objectName));
            featurePointList.forEach(featurePoint -> {
                try {
                    bw.write(",");
                    bw.write(Double.toString(featurePoint.getX()));
                    bw.write(",");
                    bw.write(Double.toString(featurePoint.getY()));
                    bw.write(",");
                    bw.write(Double.toString(featurePoint.getZ()));
                } catch (IOException ex) {
                    Logger.getLogger(FeaturePointImportService.class.getName()).log(Level.SEVERE, null, ex);
                }
            });
        }
    }
}
